<?xml version='1.0' encoding='utf-8'?>
<FilingSummary>
  <Version>3.23.2</Version>
  <ProcessingTime/>
  <ReportFormat>html</ReportFormat>
  <ContextCount>422</ContextCount>
  <ElementCount>509</ElementCount>
  <EntityCount>1</EntityCount>
  <FootnotesReported>true</FootnotesReported>
  <SegmentCount>116</SegmentCount>
  <ScenarioCount>0</ScenarioCount>
  <TuplesReported>false</TuplesReported>
  <UnitCount>9</UnitCount>
  <MyReports>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R1.htm</HtmlFileName>
      <LongName>100000 - Document - Document and Entity Information</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DocumentDocumentAndEntityInformation</Role>
      <ShortName>Document and Entity Information</ShortName>
      <MenuCategory>Cover</MenuCategory>
      <Position>1</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R2.htm</HtmlFileName>
      <LongName>100010 - Statement - CONSOLIDATED BALANCE SHEETS</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_StatementCONSOLIDATEDBALANCESHEETS</Role>
      <ShortName>CONSOLIDATED BALANCE SHEETS</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>2</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R3.htm</HtmlFileName>
      <LongName>100020 - Statement - CONSOLIDATED BALANCE SHEETS (Parenthetical)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_StatementCONSOLIDATEDBALANCESHEETSParenthetical</Role>
      <ShortName>CONSOLIDATED BALANCE SHEETS (Parenthetical)</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>3</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R4.htm</HtmlFileName>
      <LongName>100030 - Statement - CONSOLIDATED STATEMENTS OF NET (LOSS) INCOME</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_StatementCONSOLIDATEDSTATEMENTSOFNETLOSSINCOME</Role>
      <ShortName>CONSOLIDATED STATEMENTS OF NET (LOSS) INCOME</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>4</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R5.htm</HtmlFileName>
      <LongName>100040 - Statement - CONSOLIDATED STATEMENTS OF COMPREHENSIVE (LOSS) INCOME</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/StatementConsolidatedStatementsOfComprehensiveLossIncome</Role>
      <ShortName>CONSOLIDATED STATEMENTS OF COMPREHENSIVE (LOSS) INCOME</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>5</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R6.htm</HtmlFileName>
      <LongName>100050 - Statement - CONSOLIDATED STATEMENTS OF SHAREHOLDERS' EQUITY</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_StatementCONSOLIDATEDSTATEMENTSOFSHAREHOLDERSEQUITY</Role>
      <ShortName>CONSOLIDATED STATEMENTS OF SHAREHOLDERS' EQUITY</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>6</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R7.htm</HtmlFileName>
      <LongName>100060 - Statement - CONSOLIDATED STATEMENTS OF CASH FLOWS</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_StatementCONSOLIDATEDSTATEMENTSOFCASHFLOWS</Role>
      <ShortName>CONSOLIDATED STATEMENTS OF CASH FLOWS</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>7</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R8.htm</HtmlFileName>
      <LongName>100070 - Disclosure - General and Summary of Significant Accounting Policies</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPolicies</Role>
      <ShortName>General and Summary of Significant Accounting Policies</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>8</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R9.htm</HtmlFileName>
      <LongName>100080 - Disclosure - Business Combination Achieved in Stages</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBusinessCombinationAchievedInStages</Role>
      <ShortName>Business Combination Achieved in Stages</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>9</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R10.htm</HtmlFileName>
      <LongName>100090 - Disclosure - Accounts Receivable</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccountsReceivable</Role>
      <ShortName>Accounts Receivable</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>10</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R11.htm</HtmlFileName>
      <LongName>100100 - Disclosure - Revenue from Contracts with Customers</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureRevenueFromContractsWithCustomers</Role>
      <ShortName>Revenue from Contracts with Customers</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>11</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R12.htm</HtmlFileName>
      <LongName>100110 - Disclosure - Inventories</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureInventories</Role>
      <ShortName>Inventories</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>12</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R13.htm</HtmlFileName>
      <LongName>100120 - Disclosure - Property, Plant, and Equipment</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosurePropertyPlantAndEquipment1</Role>
      <ShortName>Property, Plant, and Equipment</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>13</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R14.htm</HtmlFileName>
      <LongName>100130 - Disclosure - Intangible Assets</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssets</Role>
      <ShortName>Intangible Assets</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>14</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R15.htm</HtmlFileName>
      <LongName>100150 - Disclosure - Accrued Expenses</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccruedExpenses</Role>
      <ShortName>Accrued Expenses</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>15</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R16.htm</HtmlFileName>
      <LongName>100160 - Disclosure - Upholstery Fabrics Segment Restructuring Activities</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivities</Role>
      <ShortName>Upholstery Fabrics Segment Restructuring Activities</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>16</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R17.htm</HtmlFileName>
      <LongName>100170 - Disclosure - Lines of Credit</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureLinesOfCredit</Role>
      <ShortName>Lines of Credit</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>17</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R18.htm</HtmlFileName>
      <LongName>100180 - Disclosure - Income Taxes</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxes</Role>
      <ShortName>Income Taxes</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>18</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R19.htm</HtmlFileName>
      <LongName>100190 - Disclosure - Commitments and Contingencies</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingencies</Role>
      <ShortName>Commitments and Contingencies</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>19</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R20.htm</HtmlFileName>
      <LongName>100200 - Disclosure - Stock-Based Compensation</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensation</Role>
      <ShortName>Stock-Based Compensation</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>20</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R21.htm</HtmlFileName>
      <LongName>100210 - Disclosure - Fair Value</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureFairValue</Role>
      <ShortName>Fair Value</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>21</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R22.htm</HtmlFileName>
      <LongName>100220 - Disclosure - Net (Loss) Income Per Share</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShare1</Role>
      <ShortName>Net (Loss) Income Per Share</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>22</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R23.htm</HtmlFileName>
      <LongName>100230 - Disclosure - Benefit Plans</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBenefitPlans</Role>
      <ShortName>Benefit Plans</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>23</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R24.htm</HtmlFileName>
      <LongName>100240 - Disclosure - Segment Information</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformation</Role>
      <ShortName>Segment Information</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>24</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R25.htm</HtmlFileName>
      <LongName>100250 - Disclosure - Statutory Reserves</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStatutoryReserves</Role>
      <ShortName>Statutory Reserves</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>25</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R26.htm</HtmlFileName>
      <LongName>100260 - Disclosure - Common Stock Repurchase Program</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommonStockRepurchaseProgram</Role>
      <ShortName>Common Stock Repurchase Program</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>26</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R27.htm</HtmlFileName>
      <LongName>100270 - Disclosure - Dividend Program</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureDividendProgram</Role>
      <ShortName>Dividend Program</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>27</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R28.htm</HtmlFileName>
      <LongName>100280 - Disclosure - General and Summary of Significant Accounting Policies (Policies)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPoliciesPolicies</Role>
      <ShortName>General and Summary of Significant Accounting Policies (Policies)</ShortName>
      <MenuCategory>Policies</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPolicies</ParentRole>
      <Position>28</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R29.htm</HtmlFileName>
      <LongName>100290 - Disclosure - General and Summary of Significant Accounting Policies (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPoliciesTables</Role>
      <ShortName>General and Summary of Significant Accounting Policies (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPolicies</ParentRole>
      <Position>29</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R30.htm</HtmlFileName>
      <LongName>100300 - Disclosure - Business Combination Achieved in Stages (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBusinessCombinationAchievedInStagesTables</Role>
      <ShortName>Business Combination Achieved in Stages (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBusinessCombinationAchievedInStages</ParentRole>
      <Position>30</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R31.htm</HtmlFileName>
      <LongName>100310 - Disclosure - Accounts Receivable (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccountsReceivableTables</Role>
      <ShortName>Accounts Receivable (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccountsReceivable</ParentRole>
      <Position>31</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R32.htm</HtmlFileName>
      <LongName>100320 - Disclosure - Revenue from Contracts with Customers (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureRevenueFromContractsWithCustomersTables</Role>
      <ShortName>Revenue from Contracts with Customers (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureRevenueFromContractsWithCustomers</ParentRole>
      <Position>32</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R33.htm</HtmlFileName>
      <LongName>100330 - Disclosure - Inventories (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureInventoriesTables</Role>
      <ShortName>Inventories (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureInventories</ParentRole>
      <Position>33</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R34.htm</HtmlFileName>
      <LongName>100340 - Disclosure - Property, Plant, and Equipment (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosurePropertyPlantAndEquipmentTables</Role>
      <ShortName>Property, Plant, and Equipment (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/DisclosurePropertyPlantAndEquipment1</ParentRole>
      <Position>34</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R35.htm</HtmlFileName>
      <LongName>100350 - Disclosure - Intangible Assets (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssetsTables</Role>
      <ShortName>Intangible Assets (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssets</ParentRole>
      <Position>35</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R36.htm</HtmlFileName>
      <LongName>100370 - Disclosure - Accrued Expenses (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccruedExpensesTables</Role>
      <ShortName>Accrued Expenses (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccruedExpenses</ParentRole>
      <Position>36</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R37.htm</HtmlFileName>
      <LongName>100380 - Disclosure - Upholstery Fabrics Segment Restructuring Activities (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivitiesTables</Role>
      <ShortName>Upholstery Fabrics Segment Restructuring Activities (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivities</ParentRole>
      <Position>37</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R38.htm</HtmlFileName>
      <LongName>100390 - Disclosure - Income Taxes (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesTables</Role>
      <ShortName>Income Taxes (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxes</ParentRole>
      <Position>38</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R39.htm</HtmlFileName>
      <LongName>100400 - Disclosure - Commitments and Contingencies (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingenciesTables</Role>
      <ShortName>Commitments and Contingencies (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingencies</ParentRole>
      <Position>39</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R40.htm</HtmlFileName>
      <LongName>100410 - Disclosure - Stock-Based Compensation (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationTables</Role>
      <ShortName>Stock-Based Compensation (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensation</ParentRole>
      <Position>40</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R41.htm</HtmlFileName>
      <LongName>100420 - Disclosure - Fair Value (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureFairValueTables</Role>
      <ShortName>Fair Value (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureFairValue</ParentRole>
      <Position>41</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R42.htm</HtmlFileName>
      <LongName>100430 - Disclosure - Net (Loss) Income Per Share (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShareTables</Role>
      <ShortName>Net (Loss) Income Per Share (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShare1</ParentRole>
      <Position>42</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R43.htm</HtmlFileName>
      <LongName>100440 - Disclosure - Segment Information (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformationTables</Role>
      <ShortName>Segment Information (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformation</ParentRole>
      <Position>43</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R44.htm</HtmlFileName>
      <LongName>100450 - Disclosure - General and Summary of Significant Accounting Policies - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureGeneralAndSummaryOfSignificantAccountingPoliciesNarrativeDetail</Role>
      <ShortName>General and Summary of Significant Accounting Policies - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPoliciesTables</ParentRole>
      <Position>44</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R45.htm</HtmlFileName>
      <LongName>100460 - Disclosure - General and Summary of Significant Accounting Policies - Summary of Cash and Cash Equivalents by Geographic Area (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureGeneralAndSummaryOfSignificantAccountingPoliciesSummaryOfCashAndCashEquivalentsByGeographicAreaDetail</Role>
      <ShortName>General and Summary of Significant Accounting Policies - Summary of Cash and Cash Equivalents by Geographic Area (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>45</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R46.htm</HtmlFileName>
      <LongName>100470 - Disclosure - General and Summary of Significant Accounting Policies - Summary of Foreign Currency Exchange Gains (Losses) by Geographic Area (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureGeneralAndSummaryOfSignificantAccountingPoliciesSummaryOfForeignCurrencyExchangeGainsLossesByGeographicAreaDetail</Role>
      <ShortName>General and Summary of Significant Accounting Policies - Summary of Foreign Currency Exchange Gains (Losses) by Geographic Area (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>46</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R47.htm</HtmlFileName>
      <LongName>100480 - Disclosure - Business Combination Achieved in Stages - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBusinessCombinationAchievedInStagesNarrativeDetail</Role>
      <ShortName>Business Combination Achieved in Stages - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>47</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R48.htm</HtmlFileName>
      <LongName>100490 - Disclosure - Business Combination Achieved in Stages - Schedule of Allocation of Consideration Transferred to Assets Acquired And Liabilities Assumed (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBusinessCombinationAchievedInStagesScheduleOfAllocationOfConsiderationTransferredToAssetsAcquiredAndLiabilitiesAssumedDetail</Role>
      <ShortName>Business Combination Achieved in Stages - Schedule of Allocation of Consideration Transferred to Assets Acquired And Liabilities Assumed (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>48</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R49.htm</HtmlFileName>
      <LongName>100500 - Disclosure - Business Combination Achieved in Stages - Schedule of Unaudited Pro Forma Consolidated Results of Operations (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBusinessCombinationAchievedInStagesScheduleOfUnauditedProFormaConsolidatedResultsOfOperationsDetail</Role>
      <ShortName>Business Combination Achieved in Stages - Schedule of Unaudited Pro Forma Consolidated Results of Operations (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>49</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R50.htm</HtmlFileName>
      <LongName>100510 - Disclosure - Accounts Receivable - Summary of Accounts Receivable (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccountsReceivableSummaryOfAccountsReceivableDetail</Role>
      <ShortName>Accounts Receivable - Summary of Accounts Receivable (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>50</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R51.htm</HtmlFileName>
      <LongName>100520 - Disclosure - Accounts Receivable - Summary of the Activity in the Allowance for Doubtful Accounts (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureAccountsReceivableSummaryOfTheActivityInTheAllowanceForDoubtfulAccountsDetail</Role>
      <ShortName>Accounts Receivable - Summary of the Activity in the Allowance for Doubtful Accounts (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>51</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R52.htm</HtmlFileName>
      <LongName>100530 - Disclosure - Accounts Receivable - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccountsReceivableNarrativeDetail</Role>
      <ShortName>Accounts Receivable - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>52</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R53.htm</HtmlFileName>
      <LongName>100540 - Disclosure - Accounts Receivable - Allowance for Returns and Allowances and Discounts (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccountsReceivableAllowanceForReturnsAndAllowancesAndDiscountsDetail</Role>
      <ShortName>Accounts Receivable - Allowance for Returns and Allowances and Discounts (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>53</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R54.htm</HtmlFileName>
      <LongName>100550 - Disclosure - Revenue from Contracts with Customers - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureRevenueFromContractsWithCustomersNarrativeDetail</Role>
      <ShortName>Revenue from Contracts with Customers - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>54</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R55.htm</HtmlFileName>
      <LongName>100560 - Disclosure - Revenue from Contracts with Customers - Summary of the Activity of Deferred Revenue (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureRevenueFromContractsWithCustomersSummaryOfTheActivityOfDeferredRevenueDetail</Role>
      <ShortName>Revenue from Contracts with Customers - Summary of the Activity of Deferred Revenue (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>55</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R56.htm</HtmlFileName>
      <LongName>100570 - Disclosure - Revenue from Contracts with Customers - Disaggregation of Revenue (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureRevenueFromContractsWithCustomersDisaggregationOfRevenueDetail</Role>
      <ShortName>Revenue from Contracts with Customers - Disaggregation of Revenue (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>56</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R57.htm</HtmlFileName>
      <LongName>100580 - Disclosure - Inventories - Summary of Inventories (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureInventoriesSummaryOfInventoriesDetail</Role>
      <ShortName>Inventories - Summary of Inventories (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>57</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R58.htm</HtmlFileName>
      <LongName>100590 - Disclosure - Inventories - Narrative (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureInventoriesNarrativeDetails</Role>
      <ShortName>Inventories - Narrative (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>58</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R59.htm</HtmlFileName>
      <LongName>100600 - Disclosure - Summary of Property, Plant, and Equipment (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureSummaryOfPropertyPlantAndEquipmentDetail</Role>
      <ShortName>Summary of Property, Plant, and Equipment (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>59</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R60.htm</HtmlFileName>
      <LongName>100610 - Disclosure - Intangible Assets - Summary of Intangible Assets (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssetsSummaryOfIntangibleAssetsDetail</Role>
      <ShortName>Intangible Assets - Summary of Intangible Assets (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>60</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R61.htm</HtmlFileName>
      <LongName>100620 - Disclosure - Intangible Asset - Tradename (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssetTradenameDetail</Role>
      <ShortName>Intangible Asset - Tradename (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>61</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R62.htm</HtmlFileName>
      <LongName>100630 - Disclosure - Intangible Assets - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssetsNarrativeDetail</Role>
      <ShortName>Intangible Assets - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>62</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R63.htm</HtmlFileName>
      <LongName>100640 - Disclosure - Intangible Assets - Summary of Change in Carrying Amount of Finite-Lived Intangible Assets (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIntangibleAssetsSummaryOfChangeInCarryingAmountOfFiniteLivedIntangibleAssetsDetail</Role>
      <ShortName>Intangible Assets - Summary of Change in Carrying Amount of Finite-Lived Intangible Assets (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>63</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R64.htm</HtmlFileName>
      <LongName>100670 - Disclosure - Accrued Expenses - Summary of Accrued Expenses (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureAccruedExpensesSummaryOfAccruedExpensesDetail</Role>
      <ShortName>Accrued Expenses - Summary of Accrued Expenses (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>64</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R65.htm</HtmlFileName>
      <LongName>100680 - Disclosure - Upholstery Fabrics Segment Restructuring Activities - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivitiesNarrativeDetail</Role>
      <ShortName>Upholstery Fabrics Segment Restructuring Activities - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivitiesTables</ParentRole>
      <Position>65</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R66.htm</HtmlFileName>
      <LongName>100690 - Disclosure - Upholstery Fabrics Segment Restructuring Activities - Summary of Restructuring Expense and Restructuring Related Charges (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivitiesSummaryOfRestructuringExpenseAndRestructuringRelatedChargesDetail</Role>
      <ShortName>Upholstery Fabrics Segment Restructuring Activities - Summary of Restructuring Expense and Restructuring Related Charges (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>66</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R67.htm</HtmlFileName>
      <LongName>100700 - Disclosure - Upholstery Fabrics Segment Restructuring Activities - Summary of Restructuring Expense and Restructuring Related Charges (Parenthetical) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivitiesSummaryOfRestructuringExpenseAndRestructuringRelatedChargesParentheticalDetail</Role>
      <ShortName>Upholstery Fabrics Segment Restructuring Activities - Summary of Restructuring Expense and Restructuring Related Charges (Parenthetical) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>67</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R68.htm</HtmlFileName>
      <LongName>100710 - Disclosure - Upholstery Fabrics Segment Restructuring Activities - Summary of Activity in Accrued Restructuring (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureUpholsteryFabricsSegmentRestructuringActivitiesSummaryOfActivityInAccruedRestructuringDetail</Role>
      <ShortName>Upholstery Fabrics Segment Restructuring Activities - Summary of Activity in Accrued Restructuring (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>68</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R69.htm</HtmlFileName>
      <LongName>100720 - Disclosure - Lines of Credit - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureLinesOfCreditNarrativeDetail</Role>
      <ShortName>Lines of Credit - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>69</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R70.htm</HtmlFileName>
      <LongName>100730 - Disclosure - Income Taxes - Allocation of Income Tax Expense (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesAllocationOfIncomeTaxExpenseDetail</Role>
      <ShortName>Income Taxes - Allocation of Income Tax Expense (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>70</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R71.htm</HtmlFileName>
      <LongName>100740 - Disclosure - Income Taxes - Income Tax Expense (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesIncomeTaxExpenseDetail</Role>
      <ShortName>Income Taxes - Income Tax Expense (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>71</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R72.htm</HtmlFileName>
      <LongName>100750 - Disclosure - Income Taxes - (Loss) Income before Income Taxes Related to Foreign and U.S. Operations (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesLossIncomeBeforeIncomeTaxesRelatedToForeignAndUSOperationsDetail</Role>
      <ShortName>Income Taxes - (Loss) Income before Income Taxes Related to Foreign and U.S. Operations (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesTables</ParentRole>
      <Position>72</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R73.htm</HtmlFileName>
      <LongName>100760 - Disclosure - Income Taxes - Differences Between Income Tax Expense from Continuing Operations at Federal Income Tax Rate and Effective Income Tax Rate (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesDifferencesBetweenIncomeTaxExpenseFromContinuingOperationsAtFederalIncomeTaxRateAndEffectiveIncomeTaxRateDetail</Role>
      <ShortName>Income Taxes - Differences Between Income Tax Expense from Continuing Operations at Federal Income Tax Rate and Effective Income Tax Rate (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>73</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R74.htm</HtmlFileName>
      <LongName>100770 - Disclosure - Income Taxes - Differences Between Income Tax Expense from Continuing Operations at Federal Income Tax Rate and Effective Income Tax Rate (Parenthetical) (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureIncomeTaxesDifferencesBetweenIncomeTaxExpenseFromContinuingOperationsAtFederalIncomeTaxRateAndEffectiveIncomeTaxRateParenthetic</Role>
      <ShortName>Income Taxes - Differences Between Income Tax Expense from Continuing Operations at Federal Income Tax Rate and Effective Income Tax Rate (Parenthetical) (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>74</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R75.htm</HtmlFileName>
      <LongName>100780 - Disclosure - Income Taxes - Deferred Tax Assets and Liabilities (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesDeferredTaxAssetsAndLiabilitiesDetail</Role>
      <ShortName>Income Taxes - Deferred Tax Assets and Liabilities (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>75</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R76.htm</HtmlFileName>
      <LongName>100790 - Disclosure - Income Taxes - Deferred Income Taxes - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesDeferredIncomeTaxesNarrativeDetail</Role>
      <ShortName>Income Taxes - Deferred Income Taxes - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>76</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R77.htm</HtmlFileName>
      <LongName>100800 - Disclosure - Income Taxes - GILTI - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesGILTINarrativeDetail</Role>
      <ShortName>Income Taxes - GILTI - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>77</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R78.htm</HtmlFileName>
      <LongName>100810 - Disclosure - Income Taxes - Deferred Income Taxes - Valuation Allowance - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesDeferredIncomeTaxesValuationAllowanceNarrativeDetail</Role>
      <ShortName>Income Taxes - Deferred Income Taxes - Valuation Allowance - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>78</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R79.htm</HtmlFileName>
      <LongName>100820 - Disclosure - Income Taxes - Summary of Valuation Allowances Against U.S. Net Deferred Income Tax Assets (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesSummaryOfValuationAllowancesAgainstUSNetDeferredIncomeTaxAssetsDetail</Role>
      <ShortName>Income Taxes - Summary of Valuation Allowances Against U.S. Net Deferred Income Tax Assets (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>79</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R80.htm</HtmlFileName>
      <LongName>100830 - Disclosure - Income Taxes - Summary of Change in Valuation Allowances Against U.S. Net Deferred Income Tax Assets (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesSummaryOfChangeInValuationAllowancesAgainstUSNetDeferredIncomeTaxAssetsDetail</Role>
      <ShortName>Income Taxes - Summary of Change in Valuation Allowances Against U.S. Net Deferred Income Tax Assets (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>80</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R81.htm</HtmlFileName>
      <LongName>100840 - Disclosure - Income Taxes - Deferred Income Taxes - Undistributed Earnings from Foreign Subsidiaries - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesDeferredIncomeTaxesUndistributedEarningsFromForeignSubsidiariesNarrativeDetail</Role>
      <ShortName>Income Taxes - Deferred Income Taxes - Undistributed Earnings from Foreign Subsidiaries - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>81</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R82.htm</HtmlFileName>
      <LongName>100850 - Disclosure - Income Taxes - Unrecognized Tax Benefit (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesUnrecognizedTaxBenefitDetail</Role>
      <ShortName>Income Taxes - Unrecognized Tax Benefit (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>82</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R83.htm</HtmlFileName>
      <LongName>100860 - Disclosure - Income Taxes - Uncertainty in Income Taxes - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesUncertaintyInIncomeTaxesNarrativeDetail</Role>
      <ShortName>Income Taxes - Uncertainty in Income Taxes - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>83</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R84.htm</HtmlFileName>
      <LongName>100870 - Disclosure - Income Taxes - Summary of Income Taxes Paid (Refunded) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesSummaryOfIncomeTaxesPaidRefundedDetail</Role>
      <ShortName>Income Taxes - Summary of Income Taxes Paid (Refunded) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>84</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R85.htm</HtmlFileName>
      <LongName>100880 - Disclosure - Income Taxes - Summary of Income Taxes Paid (Refunded) (Parenthetical) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureIncomeTaxesSummaryOfIncomeTaxesPaidRefundedParentheticalDetail</Role>
      <ShortName>Income Taxes - Summary of Income Taxes Paid (Refunded) (Parenthetical) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>85</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R86.htm</HtmlFileName>
      <LongName>100890 - Disclosure - Commitments and Contingencies - Lessee Operating Lease Right of Use Assets and Liabilities (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingenciesLesseeOperatingLeaseRightOfUseAssetsAndLiabilitiesDetail</Role>
      <ShortName>Commitments and Contingencies - Lessee Operating Lease Right of Use Assets and Liabilities (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>86</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R87.htm</HtmlFileName>
      <LongName>100900 - Disclosure - Commitments and Contingencies - Operating Leases of Lessee Disclosure (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingenciesOperatingLeasesOfLesseeDisclosureDetail</Role>
      <ShortName>Commitments and Contingencies - Operating Leases of Lessee Disclosure (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>87</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R88.htm</HtmlFileName>
      <LongName>100910 - Disclosure - Commitments and Contingencies - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingenciesNarrativeDetail</Role>
      <ShortName>Commitments and Contingencies - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>88</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R89.htm</HtmlFileName>
      <LongName>100920 - Disclosure - Commitments and Contingencies - Weighted Average Lease Term and Discount Rate (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingenciesWeightedAverageLeaseTermAndDiscountRateDetail</Role>
      <ShortName>Commitments and Contingencies - Weighted Average Lease Term and Discount Rate (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>89</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R90.htm</HtmlFileName>
      <LongName>100930 - Disclosure - Commitments and Contingencies - Lessee Operating Lease Liability Maturity (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommitmentsAndContingenciesLesseeOperatingLeaseLiabilityMaturityDetail</Role>
      <ShortName>Commitments and Contingencies - Lessee Operating Lease Liability Maturity (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>90</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R91.htm</HtmlFileName>
      <LongName>100940 - Disclosure - Stock-Based Compensation - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationNarrativeDetail</Role>
      <ShortName>Stock-Based Compensation - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>91</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R92.htm</HtmlFileName>
      <LongName>100960 - Disclosure - Stock-Based Compensation - Time Based Restricted Stock Unit Activity (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationTimeBasedRestrictedStockUnitActivityDetail</Role>
      <ShortName>Stock-Based Compensation - Time Based Restricted Stock Unit Activity (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>92</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R93.htm</HtmlFileName>
      <LongName>100970 - Disclosure - Stock-Based Compensation - Time Based Restricted Stock Unit Activity (Parenthetical) (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureStockbasedCompensationTimeBasedRestrictedStockUnitActivityParentheticalDetails</Role>
      <ShortName>Stock-Based Compensation - Time Based Restricted Stock Unit Activity (Parenthetical) (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>93</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R94.htm</HtmlFileName>
      <LongName>100980 - Disclosure - Stock-Based Compensation - Summary of Grants of Time-Based Restricted Stock Unit Awards Associated with Key Member of Management (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationSummaryOfGrantsOfTimeBasedRestrictedStockUnitAwardsAssociatedWithKeyMemberOfManagementDetail</Role>
      <ShortName>Stock-Based Compensation - Summary of Grants of Time-Based Restricted Stock Unit Awards Associated with Key Member of Management (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>94</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R95.htm</HtmlFileName>
      <LongName>100990 - Disclosure - Stock-Based Compensation - Summary of Assumptions Used to Determine Fair Value of Performance Based Restricted Stock Units (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationSummaryOfAssumptionsUsedToDetermineFairValueOfPerformanceBasedRestrictedStockUnitsDetail</Role>
      <ShortName>Stock-Based Compensation - Summary of Assumptions Used to Determine Fair Value of Performance Based Restricted Stock Units (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>95</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R96.htm</HtmlFileName>
      <LongName>101000 - Disclosure - Stock-Based Compensation - Summary of Grants of Performance Based Restricted Stock Units Associated with Senior Executives and Key Employees (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationSummaryOfGrantsOfPerformanceBasedRestrictedStockUnitsAssociatedWithSeniorExecutivesAndKeyEmployeesDetail</Role>
      <ShortName>Stock-Based Compensation - Summary of Grants of Performance Based Restricted Stock Units Associated with Senior Executives and Key Employees (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>96</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R97.htm</HtmlFileName>
      <LongName>101010 - Disclosure - Stock-Based Compensation - Summary of Grants of Performance Based Restricted Stock Units Associated with Senior Executives and Key Employees (Parenthetical) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureStockbasedCompensationSummaryOfGrantsOfPerformanceBasedRestrictedStockUnitsAssociatedWithSeniorExecutivesAndKeyEmployeesParenthet</Role>
      <ShortName>Stock-Based Compensation - Summary of Grants of Performance Based Restricted Stock Units Associated with Senior Executives and Key Employees (Parenthetical) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>97</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R98.htm</HtmlFileName>
      <LongName>101020 - Disclosure - Stock-Based Compensation - Summary of Vested Performance Based Restricted Stock Units (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationSummaryOfVestedPerformanceBasedRestrictedStockUnitsDetail</Role>
      <ShortName>Stock-Based Compensation - Summary of Vested Performance Based Restricted Stock Units (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>98</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R99.htm</HtmlFileName>
      <LongName>101030 - Disclosure - Stock-Based Compensation - Summary of Grants of Common Stock to Outside Directors (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStockBasedCompensationSummaryOfGrantsOfCommonStockToOutsideDirectorsDetail</Role>
      <ShortName>Stock-Based Compensation - Summary of Grants of Common Stock to Outside Directors (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>99</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R100.htm</HtmlFileName>
      <LongName>101040 - Disclosure - Fair Value - Recurring Basis (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureFairValueRecurringBasisDetail</Role>
      <ShortName>Fair Value - Recurring Basis (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>100</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R101.htm</HtmlFileName>
      <LongName>101050 - Disclosure - Fair Value - Nonrecurring Basis (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureFairValueNonrecurringBasisDetail</Role>
      <ShortName>Fair Value - Nonrecurring Basis (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>101</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R102.htm</HtmlFileName>
      <LongName>101060 - Disclosure - Fair Value - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureFairValueNarrativeDetail</Role>
      <ShortName>Fair Value - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>102</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R103.htm</HtmlFileName>
      <LongName>101070 - Disclosure - Net (Loss) Income Per Share - Schedule of Weighted Average Shares Used in the Computation of Basic and Diluted Net (Loss) Income Per Share (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShareScheduleOfWeightedAverageSharesUsedInTheComputationOfBasicAndDilutedNetLossIncomePerShareDetail</Role>
      <ShortName>Net (Loss) Income Per Share - Schedule of Weighted Average Shares Used in the Computation of Basic and Diluted Net (Loss) Income Per Share (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShareTables</ParentRole>
      <Position>103</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R104.htm</HtmlFileName>
      <LongName>101080 - Disclosure - Net (Loss) Income Per Share - Schedule of Unvested Common Stock not Included in the Computation of Diluted Net (Loss) Income Per Share (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShareScheduleOfUnvestedCommonStockNotIncludedInTheComputationOfDilutedNetLossIncomePerShareDetail</Role>
      <ShortName>Net (Loss) Income Per Share - Schedule of Unvested Common Stock not Included in the Computation of Diluted Net (Loss) Income Per Share (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/DisclosureNetLossIncomePerShareTables</ParentRole>
      <Position>104</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R105.htm</HtmlFileName>
      <LongName>101090 - Disclosure - Benefit Plans (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBenefitPlansDetail</Role>
      <ShortName>Benefit Plans (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureBenefitPlans</ParentRole>
      <Position>105</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R106.htm</HtmlFileName>
      <LongName>101100 - Disclosure - Segment Information - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformationNarrativeDetail</Role>
      <ShortName>Segment Information - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>106</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R107.htm</HtmlFileName>
      <LongName>101110 - Disclosure - Segment Information - International Net Sales (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformationInternationalNetSalesDetail</Role>
      <ShortName>Segment Information - International Net Sales (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>107</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R108.htm</HtmlFileName>
      <LongName>101120 - Disclosure - Segment Information - International Net Sales (Parenthetical) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformationInternationalNetSalesParentheticalDetail</Role>
      <ShortName>Segment Information - International Net Sales (Parenthetical) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>108</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R109.htm</HtmlFileName>
      <LongName>101130 - Disclosure - Segment Information - Statement of Operations for Business Segments (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureSegmentInformationStatementOfOperationsForBusinessSegmentsDetail</Role>
      <ShortName>Segment Information - Statement of Operations for Business Segments (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>109</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R110.htm</HtmlFileName>
      <LongName>101140 - Disclosure - Segment Information - Statement of Operations for Business Segments (Parenthetical) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/DisclosureSegmentInformationStatementOfOperationsForBusinessSegmentsParentheticalDetail</Role>
      <ShortName>Segment Information - Statement of Operations for Business Segments (Parenthetical) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>110</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R111.htm</HtmlFileName>
      <LongName>101150 - Disclosure - Segment Information - Balance Sheet Information by Operating Segments (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformationBalanceSheetInformationByOperatingSegmentsDetail</Role>
      <ShortName>Segment Information - Balance Sheet Information by Operating Segments (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>111</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R112.htm</HtmlFileName>
      <LongName>101160 - Disclosure - Segment Information - Balance Sheet Information by Operating Segments (Parenthetical) (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureSegmentInformationBalanceSheetInformationByOperatingSegmentsParentheticalDetail</Role>
      <ShortName>Segment Information - Balance Sheet Information by Operating Segments (Parenthetical) (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>112</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R113.htm</HtmlFileName>
      <LongName>101170 - Disclosure - Statutory Reserves - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureStatutoryReservesNarrativeDetail</Role>
      <ShortName>Statutory Reserves - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>113</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R114.htm</HtmlFileName>
      <LongName>101180 - Disclosure - Common Stock Repurchase Program (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommonStockRepurchaseProgramDetail</Role>
      <ShortName>Common Stock Repurchase Program (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureCommonStockRepurchaseProgram</ParentRole>
      <Position>114</Position>
    </Report>
    <Report instance="culp-20230430.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R115.htm</HtmlFileName>
      <LongName>101190 - Disclosure - Dividend Program - Narrative (Detail)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.culp.com/20230430/taxonomy/role/Role_DisclosureDividendProgramNarrativeDetail</Role>
      <ShortName>Dividend Program - Narrative (Detail)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>115</Position>
    </Report>
    <Report>
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <LongName>All Reports</LongName>
      <ReportType>Book</ReportType>
      <ShortName>All Reports</ShortName>
    </Report>
  </MyReports>
  <Logs>
    <Log type="Warning">[dq-0542-Deprecated-Concept] Concept PropertyPlantAndEquipmentEstimatedUsefulLives in us-gaap/2022 used in 1 facts was deprecated in us-gaap/2023 as of 2023 and should not be used. culp-20230430.htm 7263</Log>
    <Log type="Warning">[dq-0540-CurrentFiscalYearEndDate-Registrant-Value] In submission type 10-K, CurrentFiscalYearEndDate value, --04-30, should match the Entity Registrant Fiscal Year End Date "05/03" on record within EDGAR. culp-20230430.htm 16</Log>
    <Log type="Warning">[ix-0514-Hidden-Fact-Eligible-For-Transform] WARN: 7 fact(s) appearing in ix:hidden were eligible for transformation: dei:DocumentAnnualReport, dei:DocumentTransitionReport, dei:DocumentType, dei:EntityIncorporationStateCountryCode, dei:EntityRegistrantName, us-gaap:FiniteLivedIntangibleAssetUsefulLife, us-gaap:LineOfCreditFacilityInterestRateDescription -  culp-20230430.htm 8</Log>
  </Logs>
  <InputFiles>
    <File doctype="10-K" original="culp-20230430.htm">culp-20230430.htm</File>
    <File>culp-20230430.xsd</File>
    <File>culp-20230430_cal.xml</File>
    <File>culp-20230430_def.xml</File>
    <File>culp-20230430_lab.xml</File>
    <File>culp-20230430_pre.xml</File>
    <File>culp-ex21.htm</File>
    <File>culp-ex23.htm</File>
    <File>culp-ex24_a.htm</File>
    <File>culp-ex24_b.htm</File>
    <File>culp-ex24_c.htm</File>
    <File>culp-ex24_d.htm</File>
    <File>culp-ex24_e.htm</File>
    <File>culp-ex24_f.htm</File>
    <File>culp-ex31_a.htm</File>
    <File>culp-ex31_b.htm</File>
    <File>culp-ex32_a.htm</File>
    <File>culp-ex32_b.htm</File>
  </InputFiles>
  <SupplementalFiles>
    <File>img249428823_0.jpg</File>
  </SupplementalFiles>
  <BaseTaxonomies>
    <BaseTaxonomy items="1200">http://fasb.org/us-gaap/2022</BaseTaxonomy>
    <BaseTaxonomy items="37">http://xbrl.sec.gov/dei/2022</BaseTaxonomy>
  </BaseTaxonomies>
  <HasPresentationLinkbase>true</HasPresentationLinkbase>
  <HasCalculationLinkbase>true</HasCalculationLinkbase>
</FilingSummary>
